'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reduxForm = require('redux-form');

var _reactRouter = require('react-router');

var _darwino = require('@darwino/darwino');

var _DocumentForm = require('./DocumentForm');

var _DocumentForm2 = _interopRequireDefault(_DocumentForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var renderAttachmentUrl = _darwino.Richtext.renderAttachmentUrl,
    cleanAttachmentName = _darwino.Richtext.cleanAttachmentName;

/*
 * Document attachment table.
 */
var AttachmentTable = function (_Component) {
    _inherits(AttachmentTable, _Component);

    function AttachmentTable(props, context) {
        _classCallCheck(this, AttachmentTable);

        var _this = _possibleConstructorReturn(this, (AttachmentTable.__proto__ || Object.getPrototypeOf(AttachmentTable)).call(this, props, context));

        if (!(context.documentForm instanceof _DocumentForm2.default)) {
            throw new Error('AttachmentTable must be inside a component within a DocumentForm');
        }
        return _this;
    }

    // Context to read from the parent - router


    _createClass(AttachmentTable, [{
        key: 'render',
        value: function render() {
            var field = this.props.field;

            var doc = this.context.documentForm.getDocument();
            if (!doc || !doc.attachments) {
                return null;
            }
            return _react2.default.createElement(
                'table',
                { className: 'table table-condensed table-striped table-bordered table-attachments' },
                _react2.default.createElement(
                    'thead',
                    null,
                    _react2.default.createElement(
                        'tr',
                        null,
                        _react2.default.createElement(
                            'th',
                            null,
                            'Name'
                        ),
                        _react2.default.createElement(
                            'th',
                            null,
                            'Size'
                        ),
                        _react2.default.createElement(
                            'th',
                            null,
                            'Type'
                        )
                    )
                ),
                _react2.default.createElement(
                    'tbody',
                    null,
                    this.renderAttachmentRows(this.attachmentsForField(doc.attachments, field), doc.unid)
                )
            );
        }
    }, {
        key: 'attachmentsForField',
        value: function attachmentsForField(attachments, field) {
            return field ? attachments.filter(function (att) {
                return att.name.toLowerCase().indexOf(field + "^^") == 0;
            }) : attachments;
        }
    }, {
        key: 'renderAttachmentRows',
        value: function renderAttachmentRows(attachments, unid) {
            var _props = this.props,
                databaseId = _props.databaseId,
                storeId = _props.storeId;

            return attachments.map(function (att) {
                return _react2.default.createElement(
                    'tr',
                    { key: att.name },
                    _react2.default.createElement(
                        'td',
                        null,
                        _react2.default.createElement(
                            'a',
                            { href: renderAttachmentUrl(databaseId, storeId, unid, att.name), target: '_blank' },
                            cleanAttachmentName(att.name)
                        )
                    ),
                    _react2.default.createElement(
                        'td',
                        null,
                        att.length
                    ),
                    _react2.default.createElement(
                        'td',
                        null,
                        att.mimeType
                    )
                );
            });
        }
    }]);

    return AttachmentTable;
}(_react.Component);

AttachmentTable.contextTypes = {
    documentForm: _propTypes2.default.object
};
exports.default = AttachmentTable;