'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _darwinoReact = require('@darwino/darwino-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/*
 * Common dialog component.
 */

var Dialog = function (_BaseDialog) {
    _inherits(Dialog, _BaseDialog);

    function Dialog() {
        _classCallCheck(this, Dialog);

        return _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).apply(this, arguments));
    }

    _createClass(Dialog, [{
        key: 'renderHeader',
        value: function renderHeader() {
            var title = this.state.title;

            return _react2.default.createElement(
                _reactBootstrap.Modal.Header,
                { closeButton: true },
                title && _react2.default.createElement(
                    _reactBootstrap.Modal.Title,
                    null,
                    title
                )
            );
        }
    }, {
        key: 'renderBody',
        value: function renderBody() {
            var body = this.state.body;

            return _react2.default.createElement(
                _reactBootstrap.Modal.Body,
                null,
                body && typeof body === 'function' ? body(this) : body
            );
        }
    }, {
        key: 'promptDialog',
        value: function promptDialog(dialog) {
            var _props = this.props,
                label = _props.label,
                placeHolder = _props.placeHolder;

            return _react2.default.createElement(
                _reactBootstrap.FormGroup,
                null,
                label && _react2.default.createElement(
                    _reactBootstrap.ControlLabel,
                    null,
                    label
                ),
                _react2.default.createElement(_reactBootstrap.FormControl, { type: 'text', placeHolder: placeHolder, autoFocus: true,
                    value: dialog.state.value,
                    onChange: function onChange(e) {
                        return dialog.setState({ value: e.target.value });
                    } })
            );
        }
    }, {
        key: 'renderFooter',
        value: function renderFooter() {
            var actions = this.state.actions;

            var _this = this;
            return actions.length && _react2.default.createElement(
                _reactBootstrap.Modal.Footer,
                null,
                actions.map(function (a, idx) {
                    return _react2.default.createElement(
                        _reactBootstrap.Button,
                        { key: idx, bsStyle: a.btStyle || "primary", type: a.type, onClick: function onClick() {
                                return a.action(_this);
                            } },
                        a.title
                    );
                })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var show = this.state.show;

            return show && _react2.default.createElement(
                _reactBootstrap.Modal,
                { show: true, onHide: function onHide() {
                        return _this3.close(Dialog.CANCEL);
                    },
                    'aria-labelledby': 'contained-modal-title' },
                _react2.default.createElement(
                    _reactBootstrap.Form,
                    null,
                    this.renderHeader(),
                    this.renderBody(),
                    this.renderFooter()
                )
            );
        }
    }]);

    return Dialog;
}(_darwinoReact.BaseDialog);

exports.default = Dialog;