/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, { Component } from "react";
import { BaseSection } from "@darwino/darwino-react"
import { FormGroup, Panel, ControlLabel } from "react-bootstrap";

/*
 * Collapsible Section
 */
class Section extends BaseSection {

    render() {
        const { title, className } = this.props;
        return (
            <FormGroup className={className}>
                <ControlLabel onClick={this.handleClick}>
                    <i className={"glyphicon "+(this.state.expanded ? "glyphicon-chevron-down" : "glyphicon-chevron-right")}></i>
                    {title}
                </ControlLabel>
                <Panel collapsible expanded={this.state.expanded}>
                    {this.props.children}
                </Panel>
            </FormGroup>
        )               
    }
}

export default Section
